declare interface CSSBreakpointOptions extends KnownBreakpointOptions<CSSResultGroup> {
    screens: Screens;
    stylesheet?: CSSResultGroup;
    macros?: CSSMacros;
    screenSizeAt(knownBreakpoint: KnownBreakpoint): string;
    screenSizeAt(knownBreakpoint: KnownBreakpoint, alias: MediaQueryAlias): string;
    screenSizeAt(knownBreakpoint: KnownBreakpoint, alias?: MediaQueryAlias): string;
    resolveMacros(): string;
}

declare type CSSMacros = string;

declare type CSSResultGroup = any;

export declare const generateCSS: (options: CSSBreakpointOptions) => string;

export declare const generateCSSImpl: (options: CSSBreakpointOptions) => string;

export declare const generateOptimizedCSS: (options: CSSBreakpointOptions) => string;

declare type KnownBreakpoint = 'sm' | 'md' | 'lg' | 'xl' | '2xl' | 'dark' | 'light';

declare type KnownBreakpointOptions<T> = {
    [key in KnownBreakpoint]?: T;
};

declare type KnownMediaQuery = 'aspect-ratio' | 'device-height' | 'device-width' | 'min-resolution' | 'max-resolution' | 'device-aspect-ratio' | 'min-device-height' | 'max-device-height' | 'min-device-width' | 'max-device-width' | 'min-device-aspect-ratio' | 'max-device-aspect-ratio' | 'orientation' | 'min-width' | 'max-width' | 'prefers-color-scheme';

declare type MediaQueryAlias = 'min' | 'max' | 'minWidth' | 'maxWidth' | 'minimumWidth' | 'maximumWidth' | 'aspectRatio' | 'deviceHeight' | 'deviceWidth' | 'minResolution' | 'maxResolution' | 'deviceAspectRatio' | 'minDeviceHeight' | 'maxDeviceHeight' | 'minDeviceWidth' | 'maxDeviceWidth' | 'minDeviceAspectRatio' | 'maxDeviceAspectRatio' | 'orientation' | 'prefersColorScheme';

declare type ScreenBreakpoints = {
    [key in MediaQueryAlias | KnownMediaQuery]?: string;
};

declare type Screens = {
    [key in KnownBreakpoint]: ScreenBreakpoints;
};

export { }
